// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'HTMLBase.pas' rev: 5.00

#ifndef HTMLBaseHPP
#define HTMLBaseHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Db.hpp>	// Pascal unit
#include <HTMLCommon.hpp>	// Pascal unit
#include <Contnrs.hpp>	// Pascal unit
#include <HTTPApp.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Htmlbase
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS THTMLProducer;
class PASCALIMPLEMENTATION THTMLProducer : public Httpapp::TPageProducer 
{
	typedef Httpapp::TPageProducer inherited;
	
private:
	Classes::TStrings* FCustomTags;
	int TagNr;
	Htmlcommon::TGetStrEvent fAfterGetContent;
	Classes::TNotifyEvent fBeforeGetContent;
	
protected:
	DYNAMIC void __fastcall DoTagEvent(Httpapp::TTag Tag, const AnsiString TagString, Classes::TStrings* 
		TagParams, AnsiString &ReplaceText);
	
public:
	bool TagList;
	__fastcall virtual THTMLProducer(Classes::TComponent* AOwner);
	__fastcall virtual ~THTMLProducer(void);
	virtual AnsiString __fastcall Content();
	
__published:
	__property Classes::TStrings* CustomTags = {read=FCustomTags, write=FCustomTags};
	__property Htmlcommon::TGetStrEvent AfterGetContent = {read=fAfterGetContent, write=fAfterGetContent
		};
	__property Classes::TNotifyEvent BeforeGetContent = {read=fBeforeGetContent, write=fBeforeGetContent
		};
};


class DELPHICLASS THTMLBase;
class PASCALIMPLEMENTATION THTMLBase : public Httpapp::TCustomContentProducer 
{
	typedef Httpapp::TCustomContentProducer inherited;
	
private:
	void __fastcall SetCustomParams(const Classes::TStringList* Value);
	
protected:
	Classes::TStringList* FCustomParams;
	Htmlcommon::TGetStrEvent fAfterGetContent;
	Classes::TNotifyEvent fBeforeGetContent;
	AnsiString fName;
	AnsiString fValue;
	virtual AnsiString __fastcall GetContent();
	AnsiString __fastcall GetParams(char Sep);
	__property AnsiString HTMLName = {read=fName, write=fName};
	__property AnsiString HTMLValue = {read=fValue, write=fValue};
	__property Classes::TStringList* HTMLCustomParams = {read=FCustomParams, write=SetCustomParams};
	
public:
	virtual AnsiString __fastcall Content();
	__fastcall virtual ~THTMLBase(void);
	__fastcall virtual THTMLBase(Classes::TComponent* AOwner);
	
__published:
	__property Htmlcommon::TGetStrEvent AfterGetContent = {read=fAfterGetContent, write=fAfterGetContent
		};
	__property Classes::TNotifyEvent BeforeGetContent = {read=fBeforeGetContent, write=fBeforeGetContent
		};
};


class DELPHICLASS THTMLCombo;
class PASCALIMPLEMENTATION THTMLCombo : public THTMLBase 
{
	typedef THTMLBase inherited;
	
private:
	AnsiString varSelection;
	Db::TDataSet* fdataset;
	AnsiString fListFields;
	AnsiString fValFields;
	Htmlcommon::TGetChecked fOnGetChecked;
	bool varEmpty;
	int FHTMLSize;
	Classes::TStrings* FHTMLStaticOptions;
	void __fastcall SetHTMLStaticOptions(const Classes::TStrings* Value);
	
protected:
	virtual AnsiString __fastcall GetContent();
	
public:
	__fastcall virtual THTMLCombo(Classes::TComponent* AOwner);
	__fastcall virtual ~THTMLCombo(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
__published:
	__property Db::TDataSet* DataSet = {read=fdataset, write=fdataset};
	__property AnsiString HTMLVisibleFields = {read=fListFields, write=fListFields};
	__property AnsiString HTMLValueFields = {read=fValFields, write=fValFields};
	__property bool OneEmpty = {read=varEmpty, write=varEmpty, nodefault};
	__property AnsiString HTMLSelection = {read=varSelection, write=varSelection};
	__property Htmlcommon::TGetChecked OnGetChecked = {read=fOnGetChecked, write=fOnGetChecked};
	__property HTMLName ;
	__property int HTMLSize = {read=FHTMLSize, write=FHTMLSize, nodefault};
	__property HTMLCustomParams ;
	__property Classes::TStrings* HTMLStaticOptions = {read=FHTMLStaticOptions, write=SetHTMLStaticOptions
		};
};


class DELPHICLASS THTMLHidden;
class PASCALIMPLEMENTATION THTMLHidden : public THTMLBase 
{
	typedef THTMLBase inherited;
	
protected:
	virtual AnsiString __fastcall GetContent();
	
public:
	__fastcall virtual THTMLHidden(Classes::TComponent* AOwner);
	
__published:
	__property HTMLName ;
	__property HTMLValue ;
	__property HTMLCustomParams ;
public:
	#pragma option push -w-inl
	/* THTMLBase.Destroy */ inline __fastcall virtual ~THTMLHidden(void) { }
	#pragma option pop
	
};


class DELPHICLASS THTMLStatic;
class PASCALIMPLEMENTATION THTMLStatic : public THTMLBase 
{
	typedef THTMLBase inherited;
	
protected:
	virtual AnsiString __fastcall GetContent();
	
__published:
	__property HTMLValue ;
public:
	#pragma option push -w-inl
	/* THTMLBase.Destroy */ inline __fastcall virtual ~THTMLStatic(void) { }
	#pragma option pop
	#pragma option push -w-inl
	/* THTMLBase.Create */ inline __fastcall virtual THTMLStatic(Classes::TComponent* AOwner) : THTMLBase(
		AOwner) { }
	#pragma option pop
	
};


class DELPHICLASS THTMLDBField;
class PASCALIMPLEMENTATION THTMLDBField : public THTMLBase 
{
	typedef THTMLBase inherited;
	
private:
	AnsiString FField;
	Db::TDataSet* FDataSet;
	Htmlcommon::THTMLTextAttributes* FHTMLTextAttributes;
	void __fastcall SetHTMLTextAttributes(const Htmlcommon::THTMLTextAttributes* Value);
	
protected:
	virtual AnsiString __fastcall GetContent();
	
public:
	__fastcall virtual THTMLDBField(Classes::TComponent* AOwner);
	__fastcall virtual ~THTMLDBField(void);
	
__published:
	__property Db::TDataSet* DataSet = {read=FDataSet, write=FDataSet};
	__property AnsiString Field = {read=FField, write=FField};
	__property Htmlcommon::THTMLTextAttributes* HTMLTextAttributes = {read=FHTMLTextAttributes, write=SetHTMLTextAttributes
		};
};


class DELPHICLASS THTMLImage;
class PASCALIMPLEMENTATION THTMLImage : public THTMLBase 
{
	typedef THTMLBase inherited;
	
private:
	int fw;
	int fh;
	Classes::TStringList* FHTMLSrcParams;
	Db::TDataSet* FDataSet;
	AnsiString FFields;
	AnsiString FImgField;
	AnsiString FTable;
	Htmlcommon::THTMLImageType FImgType;
	bool FUseInternalHandling;
	Htmlcommon::TInternalImageHandler* FInternalHandler;
	Httpapp::THTTPMethodEvent FOnGetImageAction;
	Htmlcommon::TJpegQuality FJpegQuality;
	bool FTestInternalHandling;
	void __fastcall SetHTMLSrcParams(const Classes::TStringList* Value);
	void __fastcall SetDataSet(const Db::TDataSet* Value);
	void __fastcall TryInit(void);
	void __fastcall SetUseInternalHandling(const bool Value);
	void __fastcall SetImgField(const AnsiString Value);
	void __fastcall SetTable(const AnsiString Value);
	void __fastcall SetTestInternalHandling(const bool Value);
	
protected:
	virtual void __fastcall Loaded(void);
	virtual AnsiString __fastcall GetContent();
	
public:
	__fastcall virtual ~THTMLImage(void);
	__fastcall virtual THTMLImage(Classes::TComponent* AOwner);
	
__published:
	__property int HTMLWidth = {read=fw, write=fw, nodefault};
	__property int HTMLHeight = {read=fh, write=fh, nodefault};
	__property Classes::TStringList* HTMLSrcParams = {read=FHTMLSrcParams, write=SetHTMLSrcParams};
	__property Htmlcommon::THTMLImageType HTMLImageType = {read=FImgType, write=FImgType, default=0};
	__property Db::TDataSet* DataSet = {read=FDataSet, write=SetDataSet};
	__property AnsiString HTMLKeyFields = {read=FFields, write=FFields};
	__property AnsiString HTMLImageField = {read=FImgField, write=SetImgField};
	__property AnsiString HTMLImageTable = {read=FTable, write=SetTable};
	__property HTMLName ;
	__property HTMLValue ;
	__property HTMLCustomParams ;
	__property bool UseInternalHandling = {read=FUseInternalHandling, write=SetUseInternalHandling, nodefault
		};
	__property Httpapp::THTTPMethodEvent OnGetImageAction = {read=FOnGetImageAction, write=FOnGetImageAction
		};
	__property Htmlcommon::TJpegQuality JpegQuality = {read=FJpegQuality, write=FJpegQuality, default=50
		};
	__property bool TestInternalHandling = {read=FTestInternalHandling, write=SetTestInternalHandling, 
		stored=false, nodefault};
};


typedef void __fastcall (__closure *TGetNumRecEvent)(System::TObject* sender, int &NumRec);

typedef void __fastcall (__closure *TPreparePageEvent)(System::TObject* sender, int page, int rec_onpage
	, int npages);

typedef void __fastcall (__closure *TPrepareCellEvent)(System::TObject* sender, int page, int line, 
	int col, int rec, bool &cont);

class DELPHICLASS THTMLMultiPage;
class PASCALIMPLEMENTATION THTMLMultiPage : public THTMLBase 
{
	typedef THTMLBase inherited;
	
private:
	int FNumLines;
	int FNumCols;
	AnsiString FPageNumVar;
	Httpapp::TCustomContentProducer* FHTMLBefore;
	Httpapp::TCustomContentProducer* FHTMLAfter;
	Httpapp::TCustomContentProducer* FHTMLCell;
	TGetNumRecEvent FGetRec;
	TPrepareCellEvent FPrepareCell;
	TPreparePageEvent FPreparePage;
	int FNumLinks;
	Httpapp::THTMLTableAttributes* FTabAttr;
	Httpapp::THTMLTableRowAttributes* FRowsAttr;
	Db::TDataSet* FDataSet;
	
protected:
	virtual AnsiString __fastcall GetContent();
	
public:
	__fastcall virtual ~THTMLMultiPage(void);
	__fastcall virtual THTMLMultiPage(Classes::TComponent* AOwner);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
__published:
	__property int NumCols = {read=FNumCols, write=FNumCols, nodefault};
	__property int NumLines = {read=FNumLines, write=FNumLines, nodefault};
	__property int NumLinks = {read=FNumLinks, write=FNumLinks, nodefault};
	__property AnsiString PageNumVar = {read=FPageNumVar, write=FPageNumVar};
	__property Httpapp::TCustomContentProducer* HTMLCell = {read=FHTMLCell, write=FHTMLCell};
	__property Httpapp::TCustomContentProducer* HTMLContentBefore = {read=FHTMLBefore, write=FHTMLBefore
		};
	__property Httpapp::TCustomContentProducer* HTMLContentAfter = {read=FHTMLAfter, write=FHTMLAfter};
		
	__property Httpapp::THTMLTableAttributes* HTMLTableAttributes = {read=FTabAttr, write=FTabAttr};
	__property Httpapp::THTMLTableRowAttributes* HTMLRowsAttributes = {read=FRowsAttr, write=FRowsAttr}
		;
	__property TGetNumRecEvent OnGetNumRec = {read=FGetRec, write=FGetRec};
	__property TPrepareCellEvent OnPrepareCell = {read=FPrepareCell, write=FPrepareCell};
	__property TPreparePageEvent OnPreparePage = {read=FPreparePage, write=FPreparePage};
	__property Db::TDataSet* DataSet = {read=FDataSet, write=FDataSet};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Htmlbase */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Htmlbase;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// HTMLBase
